﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using System.Net;
using System.IO;
using System.IO.Compression;



namespace DownLoadManagerTest
{
    class WebModule
    {

        private static Dictionary<string, string> p = new Dictionary<string, string>();
        private static Boolean islogin = false;
        //private static string passkey = null;


        //回傳的網頁內容
        private StringBuilder buff;
        private bool success = false;
        private string msg = "";
       // private bool needlogin = false;
        //記錄Session及Cookie,如果登入時Session將一直存在
        private static CookieContainer cookie = new CookieContainer();

        public WebModule()
        {
            buff = new StringBuilder();


        }
        public bool isSuccess()
        {
            return success;
        }
        public string replyMsg()
        {
            return msg;
        }
        public static bool isLogin()
        {
            return islogin;
        }
        //取得網頁內容
        public string getContent()
        {
            return buff.ToString();
        }

       


        // private static readonly object _locker = new object();
        //做post事件
        public bool doPost(string sUrl, string data, string referer)
        {
            bool dosuccess = false;
            // lock (_locker)
            {
                HttpWebRequest URLConn = null;
                try
                {
                    // sUrl = sUrl.IndexOf(Prop.getProp()["server"]) > -1 ? sUrl : (Prop.getProp()["server"] + sUrl);
                    Console.WriteLine(sUrl);
                    //URL連線
                    URLConn = (HttpWebRequest)WebRequest.Create(sUrl);
                    //連線最大等待時間
                    URLConn.Timeout = 60000;
                    URLConn.Method = "POST";
                    //設定Header模擬瀏覽器
                    URLConn.UserAgent = "Mozilla/5.0 (Windows; U; Windows NT 6.0; zh-TW; rv:1.9.1.2) "
                              + "Gecko/20090729 Firefox/3.5.2 GTB5 (.NET CLR 3.5.30729)";
                    URLConn.Accept = "text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8";

                    URLConn.Headers.Set("Accept-Language",
                        "zh-tw,en-us;q=0.7,en;q=0.3");
                    URLConn.Headers.Set("Accept-Charse",
                        "Big5,utf-8;q=0.7,*;q=0.7");
                    URLConn.Headers["Accept-Encoding"] = "gzip, deflate";
                    //設定referer
                    if (referer != null)
                    {

                        URLConn.Referer = referer;
                    }
                    //純文字傳送,使用application/x-www-form-urlencoded
                    //如需傳送檔案,則需用multipart/form-data
                    URLConn.ContentType = "application/x-www-form-urlencoded";
                    //自動從導
                    URLConn.AllowAutoRedirect = true;

                    if (data == null)
                        data = "";
                    Console.WriteLine(data);
                    //把要傳送的資料變成binary
                    byte[] bytes = Encoding.UTF8.GetBytes(data);
                    URLConn.ContentLength = bytes.Length;

                    //設定Cookie,Session
                    URLConn.CookieContainer = cookie;

                    //送出post資料
                    if (data.Length > 0)
                    {
                        Stream oStreamOut = URLConn.GetRequestStream();
                        oStreamOut.Write(bytes, 0, bytes.Length);
                        //oStreamOut.Close();
                    }

                    string sResponseHeader = URLConn.GetResponse().Headers["Content-Encoding"];
                    string html = "";
                    System.IO.StreamReader webReader;

                    webReader = (new StreamReader(URLConn.GetResponse().GetResponseStream()));
                    //取回回傳內容
                    if (!string.IsNullOrEmpty(sResponseHeader))
                    {

                        if (sResponseHeader.ToLower().Contains("gzip"))
                        {

                            byte[] b = DecompressGzip(webReader.BaseStream);

                            data = System.Text.Encoding.GetEncoding("UTF-8").GetString(b);

                        }

                        else if (sResponseHeader.ToLower().Contains("deflate"))
                        {

                            byte[] b = DecompressDeflate(webReader.BaseStream);

                            data = System.Text.Encoding.GetEncoding("UTF-8").GetString(b);

                        }

                    }

                // uncompressed, standard response

                    else
                    {

                        html = webReader.ReadToEnd();

                    }
                    buff.Clear();
                    buff.Append(html);

                    dosuccess = true;
                }
                catch (Exception ex)
                {
                    Console.WriteLine(ex);

                }
                finally
                {
                    try
                    {
                        if (URLConn != null)
                        {
                            URLConn.GetResponse().Close();
                            //URLConn.GetRequestStream().Close();
                        }
                    }
                    catch (Exception exx)
                    {
                        Console.WriteLine(exx);

                    }


                }
            }
            Console.WriteLine(buff);
            return dosuccess;

        }

        private static byte[] DecompressGzip(Stream streamInput)
        {

            Stream streamOutput = new MemoryStream();
            int iOutputLength = 0;
            try
            {
                byte[] readBuffer = new byte[4096];

                /// read from input stream and write to gzip stream

                using (GZipStream streamGZip = new GZipStream(streamInput, CompressionMode.Decompress))
                {
                    int i;

                    while ((i = streamGZip.Read(readBuffer, 0, readBuffer.Length)) != 0)
                    {

                        streamOutput.Write(readBuffer, 0, i);

                        iOutputLength = iOutputLength + i;

                    }

                }

            }

            catch (Exception ex)
            {

                Console.WriteLine(ex);

            }
            /// read uncompressed data from output stream into a byte array

            byte[] buffer = new byte[iOutputLength];

            streamOutput.Position = 0;

            streamOutput.Read(buffer, 0, buffer.Length);
            return buffer;

        }

        private static byte[] DecompressDeflate(Stream streamInput)
        {

            Stream streamOutput = new MemoryStream();

            int iOutputLength = 0;

            try
            {

                byte[] readBuffer = new byte[4096];

                /// read from input stream and write to gzip stream

                using (DeflateStream streamGZip = new DeflateStream(streamInput, CompressionMode.Decompress))
                {
                    int i;

                    while ((i = streamGZip.Read(readBuffer, 0, readBuffer.Length)) != 0)
                    {

                        streamOutput.Write(readBuffer, 0, i);

                        iOutputLength = iOutputLength + i;

                    }

                }

            }

            catch (Exception ex)
            {
                Console.WriteLine(ex);
                // todo: handle exception

            }

            /// read uncompressed data from output stream into a byte array

            byte[] buffer = new byte[iOutputLength];

            streamOutput.Position = 0;

            streamOutput.Read(buffer, 0, buffer.Length);



            return buffer;

        }

        private decimal bytesProcessed = 0;
        private decimal bytesTotal = 0;
        public decimal getByteTotal()
        {
            return bytesTotal;
        }
        public decimal ByteProcess()
        {
            return bytesProcessed;
        }

        public decimal DownloadFile(string sUrl, string data, string referer, String localFilename)
        {
            // Function will return the number of bytes processed
            // to the caller. Initialize to 0 here.
            bytesProcessed = 0;
            bytesTotal = 0;

            // Assign values to these objects here so that they can
            // be referenced in the finally block
            Stream remoteStream = null;
            Stream localStream = null;
            WebResponse response = null;

            // Use a try/catch/finally block as both the WebRequest and Stream
            HttpWebRequest URLConn = null;
            try
            {
                // sUrl = sUrl.IndexOf(Prop.getProp()["server"]) > -1 ? sUrl : (Prop.getProp()["server"] + sUrl);
                Console.WriteLine(sUrl);
                //URL連線
                URLConn = (HttpWebRequest)WebRequest.Create(sUrl);
                //連線最大等待時間
                URLConn.Timeout = 60000;
                URLConn.Method = "POST";
                //設定Header模擬瀏覽器
                URLConn.UserAgent = "Mozilla/5.0 (Windows; U; Windows NT 6.0; zh-TW; rv:1.9.1.2) "
                          + "Gecko/20090729 Firefox/3.5.2 GTB5 (.NET CLR 3.5.30729)";
                URLConn.Accept = "text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8";

                URLConn.Headers.Set("Accept-Language",
                    "zh-tw,en-us;q=0.7,en;q=0.3");
                URLConn.Headers.Set("Accept-Charse",
                    "Big5,utf-8;q=0.7,*;q=0.7");
                URLConn.Headers["Accept-Encoding"] = "gzip, deflate";
                //設定referer
                if (referer != null)
                {

                    URLConn.Referer = referer;
                }
                //純文字傳送,使用application/x-www-form-urlencoded
                //如需傳送檔案,則需用multipart/form-data
                URLConn.ContentType = "application/x-www-form-urlencoded";
                //自動從導
                URLConn.AllowAutoRedirect = true;

                if (data == null)
                    data = "";
                Console.WriteLine(data);
                //把要傳送的資料變成binary
                byte[] bytes = Encoding.UTF8.GetBytes(data);
                URLConn.ContentLength = bytes.Length;

                //設定Cookie,Session
                URLConn.CookieContainer = cookie;

                //送出post資料
                if (data.Length > 0)
                {
                    Stream oStreamOut = URLConn.GetRequestStream();
                    oStreamOut.Write(bytes, 0, bytes.Length);
                    //oStreamOut.Close();
                }
                string sResponseHeader = URLConn.GetResponse().Headers["Content-Length"];
                bytesTotal = Convert.ToInt32(sResponseHeader);
                response = URLConn.GetResponse();

                if (response != null)
                {
                    // Once the WebResponse object has been retrieved,
                    // get the stream object associated with the response's data
                    remoteStream = response.GetResponseStream();

                    // Create the local file
                    localStream = File.Create(localFilename);

                    // Allocate a 1k buffer
                    byte[] buffer = new byte[1024];
                    int bytesRead;

                    // Simple do/while loop to read from stream until
                    // no bytes are returned
                    Object o = new Object();
                    do
                    {
                        // Read data (up to 1k) from the stream
                        
                            bytesRead = remoteStream.Read(buffer, 0, buffer.Length);

                            // Write the data to the local file
                            localStream.Write(buffer, 0, bytesRead);
                            //Console.WriteLine(bytesProcessed + "\t" + bytesTotal);
                            // Increment total bytes processed
                            //Console.WriteLine(bytesProcessed);
                            bytesProcessed += bytesRead;
                        
                    } while (bytesRead > 0);
                    //bytesProcessed = bytesTotal;
                }

            }
            catch (Exception e)
            {
                Console.WriteLine(e);
            }
            finally
            {
                // Close the response and streams objects here 
                // to make sure they're closed even if an exception
                // is thrown at some point
                if (response != null) response.Close();
                if (remoteStream != null) remoteStream.Close();
                if (localStream != null) localStream.Close();
            }

            // Return total bytes processed to caller.
            return bytesProcessed;
        }
    }

}
